//Подбор депозитов
(function($){
	var ServicePodborDeposit = function(){
		this.ns = '.DepositSearch';
		console.log('Подбор депозитов');
		this.$form = $('#deposit_search_form');
		this.$container = $('#deposit_search_container');
		this.$search_result = $('#deposit_search_result_container');
		this.search_params = {};
		this.form_valid = false;


		this.initEvents();
		this.validateForm();
	}
	ServicePodborDeposit.prototype.initEvents = function() {
		var _this = this;
		console.log('init events');
		//Смена Месяц\день
		this.$form.on('click', '#deposit_search_srok_type > span', function(event){
			var val = $(this).attr('data-type');

			$('.deposit_search_srok_type-active')
				.css({marginRight: 0, marginLeft: 0})
				.removeClass('deposit_search_srok_type-active');

			$(this).addClass('deposit_search_srok_type-active');
			if(val === 'mon'){
				$(this).css({marginRight: -15, marginLeft: 0});
			} else {
				$(this).css({marginRight: 0, marginLeft: -15});
			}
			$('#deposit_search_srok_type_input').val(val);
		});
		//Сабмит формы
		this.$form.on('click', '#deposit_search_submit', function(event) {
			console.log('Сабмит формы');
			_this.validateForm(true);
			return false;
		});
		//Показ формы
		this.$container.on('click', '#deposit_search_toogle_form > button', function(event){
			_this.$form.slideToggle(200);
			$('#deposit_search_toogle_form').hide();
		});
		//Сортировка списка
		this.$container.on('change', '#deposit_list_filter', function(event){
			var data_sort = $(this).val();
			_this.depositList.sort(data_sort, { order: "asc" }); 
			console.log('Сортируем по - ' + data_sort );
		});
		//Форма контакта
		this.$container.on('click', '.get-consult', function(event) {
			var contactForm = new serviceDepositContact(event);
			console.log(contactForm);
		})
	};
	//Сбор информации и валидация формы
	ServicePodborDeposit.prototype.validateForm = function(send) {
		var _this = this;
		var send = send || false;
		var inputs = {
			mindeposit: $('#search_deposit_summ').val(),
			maxdeposit: $('#search_deposit_summ_max').val(),
			cash: $('#search_deposit_currency').val(),
			period: $('#search_deposit_srok').val(),
			periodmax: $('#search_deposit_srok_max').val(),
			periodtype: $('#deposit_search_srok_type_input').val(),
			procent: $('#search_deposit_procent').val(),
			procentmax: $('#search_deposit_procent_max').val(),
			web: $('#search_deposit_web')[0].checked,
			office: $('#search_deposit_office')[0].checked,
			capitalization: $('#search_deposit_kapital')[0].checked,
			popolnenie: $('#search_deposit_popolnenie')[0].checked,
			dosrok: $('#search_deposit_dosrok')[0].checked,
			chast: $('#search_deposit_dosrokchast')[0].checked,
			progressice: $('#search_deposit_progress')[0].checked,
			pensioners: $('#search_deposit_pensioners')[0].checked
		}
		if(inputs.periodtype === 'mon'){
			inputs.period = Math.ceil(inputs.period*30);
			inputs.periodmax = Math.ceil(inputs.periodmax*30);
		}
		console.log('Валидация формы', inputs);
		_this.search_params = inputs;
		_this.form_valid = true;
		if(_this.form_valid === true & send === true){
			_this.sendForm();
		}
	};
    ServicePodborDeposit.prototype.initList = function() {
        var _this = this,
            list_options = {
                valueNames: ['bank', 'procent', 'period'],
                page: 10,
  				plugins: [ ListPagination({}) ] 
            };
        this.depositList = new List('deposit_search_result_container', list_options);
        console.log('Инит лист');
        console.log(this.depositList);

    };
	//Отправка формы
	ServicePodborDeposit.prototype.sendForm = function() {
		var _this = this;
		console.log('Отправка формы');
		_this.$form.slideToggle(200);
		$('#deposit_search_toogle_form').show();
		_this.$search_result.find('.deposit_search_result-message').html('<i class="icon-load rotating"></i> Идет поиск по базе данных...');
		_this.$search_result.find('.round_input').find('span').remove();
		$.ajax({
			url: 'index.php?option=com_deposits&view=deposits&action=ajax',
			type: 'POST',
			dataType: 'json',
			data: _this.search_params,
		})
            .done(function(data) {
                if (data.length > 0) {
                    var l = data.length;
                    _this.$search_result.find('.deposit_search_result-message').html('');
                    _this.$search_result.find('.round_input').prepend('<span>Найдено совпадений: ' + data.length + '</span>');
                    var html = '';
                    for (i = 0; l > i; i++) {
                        var deposit = data[i],
                        	cash = {
                        		rub: ' руб.',
                        		eur: ' евро',
                        		dol: ' долл.'
                        	};
                        html += '<li class="deposit_container"><a class="deposit_block-name" href="' + deposit.link + '">' + deposit.name + '</a> ';
                        html += ' <span class="get-consult a-dotted">Получить консультацию</span>';
                        html += '<span class="deposit_block-bank">' + deposit.bank + '</span>';
                        if (deposit.pensioners === '1') {
                            html += '<span class="deposit_block-pensioners-only">Только для пенсионеров</span>';
                        }
                        html += '		<div class="deposit_list_info">';
                        html += '			<ul>';
                        html += '				<li>% ставка <span> от ' + deposit.procent + ' % </span></li>';
                        if (deposit.procent_cap > 0) {
                            html += '				<li>% кап. ставка</dt><span> от ' + deposit.procent_cap + ' % </span></li>';
                        }
                        html += '				<li>Сумма <span>от ' + deposit.mindeposit + ' до ' + deposit.maxdeposit + ' '+ cash[deposit.cash] +'  </span></li>';
                        html += '				<li>Срок <span>от ' + deposit.period + ' до ' + deposit.periodmax + ' дней </span></li> ';
                        html += '			</ul>';
                        html += '		</div>';
                        html += '<div class="bank hide">' + deposit.bank + '</div>';
                        html += '<div class="procent hide">' + deposit.procent + '</div>';
                        html += '<div class="period hide">' + deposit.period + '</div>';
                        html += '</li>';
                        console.log(deposit);
                    }
                    _this.$search_result.find('.list').html(html);
                    _this.$search_result.find('.round_input, .pagination').show();
                    _this.initList();
                } else {
                    _this.$search_result.find('.deposit_search_result-message').html('Совпадений не найдено');
                    _this.$search_result.find('.list').html('');
                    _this.$search_result.find('.round_input, .pagination').hide();
                }
                console.log("success", data);
            })
		.fail(function(data) {
			console.log("error", data);
		})
		.always(function(data) {

			console.log("complete", data);
		});
		
	};
	$(document).ready(function() {
		new ServicePodborDeposit();
	});;
})(jQuery);